
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>J2ME Web 服务入门 / iVAN</title>

    <meta name="description" content="J2ME Web 服务入门 web 简介 WSA 设计用于与 J2ME 配置文件协同工作,J2ME 配置文件要么基于 Connected Device Configuration (CDC),要么基于 Connected Limited Device Configuration (CLDC 1.0 或 CLDC 1.1).远程调用 API 基于 J2SE 的 Java API for XML-Based RPC (JAX-RPC 1.1) 的一个完整子集,它包含了一些远程方法调用(Remote Method Invocat">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">J2ME Web 服务入门</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>web</p>
<p>简介</p>
<p>WSA 设计用于与 J2ME 配置文件协同工作，J2ME 配置文件要么基于 Connected Device Configuration (CDC)，要么基于 Connected Limited Device Configuration (CLDC 1.0 或 CLDC 1.1)。远程调用 API 基于 J2SE 的 Java API for XML-Based RPC (JAX-RPC 1.1) 的一个完整子集，它包含了一些远程方法调用（Remote Method Invocation，RMI）类，以满足 JAX-RPC 依赖。XML 解析 API 基于 Simple API for XML, v2 (SAX2)的一个完整子集。</p>
<p>WSA 的目标是把对 Web 服务调用和 XML 解析的基本支持集成到设备的运行时环境，这样开发人员就不必在每个应用程序中嵌入这样的功能了——在像移动电话和个人数字助理这样资源有限的设备中，这算是一个特别浪费资源的问题。</p>
<p>核心规范</p>
<p>Web Services Interoperability Organization (WS-I) 促进了定义 Web 服务的核心规范和应用层协议，并且它们受 World Wide Web Consortium (W3C) 和 Organization for the Advancement of Structured Information Standards (OASIS) 的指导。4 个关键标准规定了如何创建、部署、发现以及如何使用 Web 服务：</p>
<p>Web 服务标准 描述 <br />Simple Object Access Protocol (SOAP) 1.1 定义了传输和数据编码 <br />Web Services Definition Language (WSDL) 1.1 定义了如何描述远程服务 <br />Universal Description, Discovery, &amp; Integration (UDDI) 2.0 定义了如何发现远程服务 <br />Extensible Markup Language (XML) 1.0 和 XML Schema 定义了可扩展标记语言（Extensible Markup Language ，XML） 和 XML 模式（Schema）</p>
<p>这些主要规范往往非常广泛，而且 Web 服务开发人员已发现难以实现完全互操作性。为了解决标准解释中存在的差异，WS-I 已定义了一组称作 WS-I Basic Profile, version 1.0 的一致性规则。JSR 172 符合基本配置文件（Basic Profile）。</p>
<p>J2ME 平台上的 Web 服务</p>
<p>JSR 172 规定了标准化客户端技术，允许 J2ME 应用程序在典型 Web 服务架构上使用远程服务，如图 1 所示：</p>
<p>图 1  在典型 Web 服务架构上的 J2ME Web 服务</p>
<p>在高层，该 Web 服务架构具有三个元素：</p>
<p>驻留在支持 WSA 无线设备上的网络感知应用程序。该应用程序包括使用 JSR 172 运行库与网络进行通信的 JSR 172 存根。下文将会描述存根和运行库所扮演的角色。 <br />无线网络和 Internet 以及对应的通信和数据编码协议，包括二进制协议、HTTP 以及 SOAP/XML. <br />Web 服务器，扮演服务提供者的角色，通常在一个或多个防火墙和代理网关后面。Web 服务器通常提供对专用网络上后端应用程序和服务器的访问。 <br />WSA 的第一个版本只解决了 Web 服务的使用，不支持服务端点的创建和开发；J2ME 设备可以是服务用户，但不可以是服务提供者。JSR 172 还没有规定使用 UDDI 的服务发现的 API。</p>
<p>了解 JSR 172</p>
<p>首先考查如何组织典型的基于 JSR 172 的应用程序，开始了解 J2ME Web Services 是如何运作的：</p>
<p>该应用程序本身是一个基于移动信息设备配置文件（Mobile Information Device Profile，MIDP）或个人基础配置文件（Personal Basis Profile，PBP)）的智能客户机，具有特定于业务的逻辑、用户界面、持久性逻辑以及生命周期和应用程序状态管理。该应用程序可以使用 JAXP 子集 API 来处理 XML 文档。还可以使用 JAX-RPC 子集 API 来使用 Web 服务，从而使用 JSR 172 存根和运行库。</p>
<p>在像手提电话这样的设备中，应用程序和 JSR 172 存根通常驻留在设备内存中，而所有 JSR 172 元素连同基础配置文件和配置一起嵌入到设备本身。</p>
<p>JSR 172 运行库和服务提供者接口</p>
<p>在 JSR 172 操作的中心是运行库，带有服务提供者接口，允许存根执行所有与调用 RPC 服务端点有关的任务：</p>
<p>设置特定于 RPC 调用的属性。 <br />描述 RPC 调用输入和返回值。 <br />编码输入值。 <br />调用 RPC 服务端点。 <br />对应用程序解码并为其返回服务端点所返回的全部值。 <br />图 3 描绘出了客户机应用程序、存根以及运行库三者之间的关系：</p>
<p>图 3  JSR 172 运行库和 SPI</p>
<p>虽然 JSR 172 运行库隐藏了像连接管理和数据编码这样的复杂性，但 SPI 从运行库实现细节分离出了存根，从而允许存根在供应商实现之间的可移植性。</p>
<p>客户机应用程序不直接与运行库和 SPI 进行交互；而是使用存根。运行库和 SPI 主要为打算开发 JSR 172 运行库和自动化工具的第三方供应商所关心，比如开发人员用于生成存根的 WSDL 到 Java 映射工具。</p>
<p>由于应用程序开发人员不直接使用 SPI，因此本文不会较详尽地介绍运行库和 SPI。如果想了解关于它们的更多信息，可以查阅 JSR 172 规范。</p>
<p>JSR 172 JAX-RPC 子集 API</p>
<p>正如前面所提到的，JSR 172 Web 服务远程调用 API 基于 J2SE 的 JAX-RPC 1.1 API 的一个完整子集。以下列表在高层描述了该子集。要了解详细信息，请参阅 JSR 172 specification：</p>
<p>符合 WS-I Basic Profile。 <br />支持 SOAP 1.1。 <br />支持所有传输，比如 HTTP 1.1，它可以传送 SOAP 消息，而且具有一个捆绑 SOAP 1.1 的已定义协议。 <br />支持全套数据类型：逻辑型、字符型、短整型、整型、长整型、浮点型、双精度型、字符串型（String）、基本类型数组以及复杂类型（包括基本或复杂类型的结构）。</p>
<p>注意，真正的浮点支持只在基于 CDC 或基于 CLDC 1.1. On CLDC 1.0 的软件堆栈中出现，浮点型和双精度型映射为 String。还要注意，所支持的数据类型会约束所支持的 WSDL 数据类型。后面的部分将讨论 WSDL 到 Java 数据类型映射。</p>
<p>支持表示 RPC 调用或响应(使用 Document/Literal 消息传递模式的 WSDL 操作)的 SOAP 消息的 Literal 表示；不支持 Encoded 表示。 <br />不支持带有附件的 SOAP 消息。 <br />不支持 SOAP 消息处理程序。 <br />不支持服务端点；即不允许设备是 Web 服务提供者。 <br />不提供发现支持(UDDI). <br />要减少对网络带宽的需求——以及要节省用户的时间和每字节的开销，请不要在设备本身上强制使用 XML 编码。</p>
<p>注：实现可能会使用更高效的编码，比如设备与无线网关间的二进制协议，只要它对消费者和生产者来说都是透明的。</p>
<p>下表描述了 JSR 172 JAX-RPC 子集中的软件包：</p>
<p>Java\ 软件包 描述 <br />javax.microedition.xml.rpc 定义了存根使用的 Type，它是合法简单类型的枚举：逻辑型、字节型、短整型、整型、长整型、浮点型、双精度型、 String <br />定义了存根使用的 ComplexType，它是表示 WSDL xsd:complextype 定义的特殊类型 <br />定义了存根使用的 Element，它表示 WSDL xsd:element 定义 <br />定义了存根使用的 Operation，它表示服务端点的 WSDL wsdl:operation  <br />定义了 FaultDetailHandler，这是一个处理自定义故障的存根所实现的接口 <br />定义了存根使用的 FaultDetailException，这是一个 Exception 类，表示运行时实现抛出的作为 JAXRPCException 结果的异常；为 service-specificDefines 返回存根异常详细值所使用的 QName（限定名）类，并将相关的 QName 返回给 Stub 实例 <br />javax.xml.namespace 定义了存根所使用的 QName（限定名）类 <br />javax.xml.rpc 定义了 Stub 接口，这是所有 JAX-RPC 存根的基本接口；还定义了 NamespaceConstants 以及与 JAXRPCException 有关的类 <br />java.rmi 标准 java.rmi 软件包子集，包含它以满足 JAX-RPC 依赖性；只定义了 Remote 处理程序和三个异常类：MarshalException、 RemoteException 和 ServerException</p>
<p>除了像 RemoteException 这样的异常，存根还使用大多数上述 API；应用程序本身使用存根。</p>
<p>在应用程序中使用 JAX-RPC 子集</p>
<p>创建 JSR 172 JAX-RPC 客户机的一般步骤如下：</p>
<p>从描述远程 Web 服务的 WSDL XML 文档生成 JSR 172 JAX-RPC 存根类。 <br />在自己的代码中创建生成存根的实例。 <br />实例化之后，调用生成存根的方法。这些方法与 WSDL XML 文档中服务端点的 wsdl:操作相对应。 <br />生成 JSR 172 JAX-RPC 存根</p>
<p>客户机应用程序通过存根和设备的 JSR 172 运行库与远程服务进行交互。该运行库隐藏了与连接、SOAP 以及数据编码管理相关的复杂性。</p>
<p>要与运行库进行交互，客户机通常使用存根生成器所生成的存根或者 WSDL 到 Java 的映射工具，它们用于在 WSDL 文档中输入远程服务接口定义，并生成使用 JAX-RPC 子集 API 和运行库 SPI 的存根类。虽然也能手工开发这些存根，但使用该生成器效果会更佳。下图概述了存根的生成：</p>
<p>生成 JSR 172 存根的一般步骤。 最后所得到的存根类实现了 Stub Interface 和服务的远程接口，并使用了支持类。</p>
<p>生成 JSR 172 JAX-RPC 存根的步骤类似于创建基于 RMI 的应用程序的步骤。在标准 RMI 中，RMI 编译器 (rmic) 从远程接口定义生成存根。如图 4 所示，创建 WSA 应用程序之后，WSDL 到 Java 的映射工具从 WSDL XML 文件生成存根。映射工具生成远程接口 Java 文件和支持类，它们由生成的存根本身所使用。然后将 JSR 172 存根编译为 Java 类，并同应用程序一起打包。</p>
<p>Sun 的 J2ME Wireless Toolkit V2.1 包含 JSR 172 JAX-RPC 存根生成器——本文稍后将讲述如何使用它。第三方供应商提供了自己的存根生成器。</p>
<p>使用 JSR 172 JAX-RPC 存根</p>
<p>存根一旦生成了，应用程序就可以使用它了。以下代码片段使用了称作 PubService 的服务，以便检索无线技术文章：</p>
<p>package j2medeveloper.pubwebservice</p>
<p>// MIDP</p>
<p>import javax.microedition.midlet.MIDlet;</p>
<p>import javax.microedition.lcdui.Display;</p>
<p>import javax.microedition.lcdui.Form;</p>
<p>...</p>
<p>// JAX-RPC</p>
<p>import java.rmi.RemoteException;</p>
<p>// JAX-RPC</p>
<p>String serviceURL = "www.j2medeveloper.com/pubwebservice";</p>
<p>String articleID = "IntroJSR172";</p>
<p>...</p>
<p>// Instantiate the service stub.</p>
<p>PubService_Stub service = new PubService_Stub();</p>
<p>// Set up the stub.</p>
<p>service._setProperty(Stub.ENDPOINT_ADDRESS_PROPERTY, serviceURL);</p>
<p>service._setProperty(Stub.SESSION_MAINTAIN_PROPERTY, new Boolean(true));</p>
<p>...</p>
<p>try {</p>
<p>// Invoke the PubService method getArticleByID() to retrieve</p>
<p>// a specific article by ID. A WirelessArticle represents an</p>
<p>// article and has methods to get the article's author, date,</p>
<p>// title, summary, and body. PubService also has a method to</p>
<p>// get the PubService's RSS feed.</p>
<p>WirelessArticle article = service.getArticleByID(articleID);</p>
<p>// Create a Form to display the article.</p>
<p>javax.microedition.lcdui.Form form =</p>
<p>new Form(article.getShortTitle());</p>
<p>form.append(wrap(article.getSummary()));</p>
<p>...</p>
<p>...</p>
<p>display.setCurrent(form);</p>
<p>} catch (RemoteException e) {</p>
<p>// Handle RMI exception.</p>
<p>} catch (Exception e) {</p>
<p>// Handle exception.</p>
<p>}</p>
<p>...</p>
<p>使用存根会使远程服务调用变得非常容易。该代码用例子说明了 PubService_Stub，初始化了实例，并调用了它的其中一个方法 getArticleByID()，以便对文章本身进行检索。然后，应用程序使用了文章的访问方法来获取文章的标题、摘要等等。</p>
<p>注意，因为调用 PubService_Stub.getArticleByID() 是分块调用，因此在实际应用程序中，要用分离的线程来分派该调用。在 WSA 中，方法调用遵循常见的客户机/服务器交互的同步请求-响应模型：客户机向服务器发出请求，然后等待服务器的响应：</p>
<p>图 5  同步请求/响应模型</p>
<p>如何对方法及其参数进行编码、序列化和发送，以及如何接收、解码和反序列化响应，对应用程序来说是完全透明的。JSR 172 存根和运行库处理所有这些单调冗长的细节。</p>
<p>将 WSDL 数据类型映射到 Java</p>
<p>下面简要考察一下 JSR 172 的 JAX-RPC 子集 API 中的 WSDL 到 Java 的数据类型映射：</p>
<p>WSDL 数据类型 Java 数据类型</p>
<p>xsd:string  String <br />xsd:int int 或 Integer <br />xsd:long long 或 Long <br />xsd:short  short 或 Short <br />xsd:boolean  boolean 或 Boolean <br />xsd:byte  byte 或 Byte <br />xsd:float String、float 或 Float <br />xsd:double  String、double 或 Double <br />xsd:QName javax.xml.namespace.QName <br />xsd:base64Binary byte[] <br />xsd:hexBinary byte[] <br />Arrays 取决于 XML 数组的模式 <br />xsd:complexType 基本和类类型的序列</p>
<p>别忘了，因为 CLDC 1.0 不支持浮点类型，因此一定要将浮点型和双精度型映射为 String 型。当目标既包含 CLDC 1.0 又包含 CLDC 1.1 平台时，开发人员应使用该默认映射。</p>
<p>要了解关于 WSDL 的更多信息，请参阅 JSR 172 specification 和 W3C's WSDL specification。</p>
<p>在应用程序中使用 JAXP 子集</p>
<p>现在将注意力转移到 JAXP 子集——其他 JSR 172 API。记得 JAXP 和 JAX-RPC 都是可选软件包；它们彼此独立地存在。</p>
<p>JAXP XML 解析 API 基于 Simple API for XML v2（SAX2）的一个完整子集。虽然标准 SAX2 API 中的大多数类没被包含在该子集中，但保留有所有必要的核心功能。</p>
<p>以下列表在高层描述了 JAXP 子集。要了解更多信息，请参阅 JSR 172 specification：</p>
<p>基于 SAX 2.0 的一个完整子集  不支持 SAX 1.0，因为 SAX 2.0 已将它取代了。</p>
<p>支持 XML 命名空间 <br />既支持 UTF-8 又支持 UTF-16 字符编码。 <br />要么不支持文档对象模型（Document Object Model (DOM)）的 Level 1.0 ，要么不支持 DOM 的 Level 2.0 ，因为考虑到它太笨重。 <br />不支持可扩展样式表语言转换（Extensible Stylesheet Language Transformations，XSLT）。 <br />支持文档类型定义（Document Type Definition，DTD）。</p>
<p>解析器可以根据 XML 文档类型的指定内部或外部定义来对这些文档进行验证。 JSR 172 规定，文档验证是可选的，因为该操作开销极大，一个文档在限制较高的基于 CLDC 的环境不适合，但可能会在更高端的基于 CDC 的平台上获得成功。如果跳过 DTD 处理，DefaultHandler.skippedEntity() 方法就会通知应用程序。该逻辑符合 XML 1.0 规范。</p>
<p>下表描述了 JSR 172 JAXP 子集中的软件包：</p>
<p>Java 软件包 描述 <br />javax.xml.parsers 定义了 SAXParser，这是一个表示简单的基于 SAX 的解析器的 API。 <br />定义了 SAXParserFactory，这是一个获得和配置基于 SAX 的解析器的工厂。 <br />定义了 ParserConfigurationException，抛出时指示配置错误。 <br />定义了 FactoryConfigurationError，抛出时指示解析器工厂的问题。 <br />org.xml.sax 定义了 Attributes，这是一个通过以下形式提供对属性列表进行访问的接口： <br />属性索引 <br />限定命名空间的名称 <br />限定（前缀）名称</p>
<p>定义了 Locator，这是一个用于将 SAX 事件与文档位置相关联的接口。通过使用 Locator（该 Locator 通过调用 DefaultHandler 对象的 setDocumentLocator() 方法而指定）的实例，该应用程序可以获取解析事件位置信息，比如事件行号、列号以及公共和系统标识符。 <br />Locator 提供了获取当前文档事件结束位置的行号、列号的方法以及获取当前文档事件的公共和系统标识符的方法。</p>
<p>定义了 InputSource，它封装输入源。它提供了获取或设置字节流、字符集、编码以及公共和系统标识符的方法。 <br />定义了通用 SAX 异常类、SAXException 以及三个子类： SAXNotRecognizedException、SAXNotSupportedException 和 SAXParseException <br />org.xml.sax.helpers 定义了 DefaultHandler，这是 SAX2 事件处理程序的基类。它提供了要扩展的应用程序的事件处理行为的缺省实现。应用程序开发人员只需覆盖相关的方法，就可以设计解析行为。 <br />在读取 XML 流的时候，当解析器与 XML 元素或属性发生冲突时，它就通过调用其中一个 DefaultHandler 方法来通知确定事件的应用程序；例如：</p>
<p>startDocument() 和 endDocument()，在 XML 文档的开头和末尾 <br />startElement() 和 endElement()，在 XML 元素的开头和末尾 <br />characters()，当在元素内部发现字符数据时 <br />skippedEntity()，当跳过一个实体时 <br />JSR 172 specification 描述了 DefaultHandler 方法的其余部分。</p>
<p>以下方法定义显示了如何使用 JAXP 来解析从 PubService 检索的 RSS 提要：</p>
<p>/**<br /> * Invoke the service and parse the RSS feed.<br /> */<br />private void parseRSSfeed() {<br />  try {<br />    // Create a RSS parser handler<br />    parser = new RSSParserHandler();<br />    try {<br />      SAXParserFactory factory = SAXParserFactory.newInstance();<br />      saxParser = factory.newSAXParser();<br />    } catch (Exception e) {<br />      // Handle exception...<br />      return;<br />    }<br />    // Invoke the remote service method getRSSFeed to <br />    // retrieve the RSS feed for the Pub service<br />    // web site.</p>
<p>String rssFeed = service.getRSSFeed();</p>
<p>// Parse the RSS feed.<br />    byte[] rssFeedByteArray = rssFeed.getBytes("UTF-8");<br />    ByteArrayInputStream rssFeedByteArrayInputStream = <br />      new ByteArrayInputStream(rssFeedByteArray);</p>
<p>saxParser.parse(rssFeedByteArrayInputStream, parser);<br />  } catch (RemoteException e) {<br />    // Handle RMI exception.<br />  } catch (Exception e) {<br />    // Handle exception.<br />  }<br />}</p>
<p>parseRSSfeed() 方法使用 PubService_Stub.getRSSFeed() 远程服务来检索 PubService 的 RSS Content XML 文档，然后将其传递到 JAXP RSS-feed XML 解析器。以下类定义显示了如何实现负责解析 RSS 提要的处理程序：</p>
<p>/**<br /> * RSS Parser handler class to parse the RSS feed from the <br /> * server.<br /> */</p>
<p>class RSSParserHandler extends DefaultHandler {<br />    // Stack to keep track of document parsing.<br />    Stack stack;</p>
<p>// Current document element.<br />    Object current;</p>
<p>/** Start of document processing. */<br />    public void startDocument() {<br />        rssParsingComplete = false;<br />        title = link = description = null;<br />        stack = new Stack();<br />    }</p>
<p>/** Process the new element. */<br />    public void startElement(<br />            String uri, String localName, String qName,<br />            Attributes attributes) throws SAXException {<br />        if ("item".equals(qName)) {<br />            title = link = description = null;<br />        }<br />        stack.push(qName);<br />    }</p>
<p>/** Process the character data for current tag. */ <br />    public void characters(<br />            char[] ch, int start, int length) {<br />        Object current = stack.peek();<br />        if ("title".equals(qName)) {<br />            title = new String(ch, start, length));<br />        } else if ("link".equals(qName)) {<br />            link = new String(ch, start, length));<br />        } else if ("description".equals(qName)) {<br />            description = new String(ch, start, length));<br />        }<br />    }</p>
<p>/** Process the end element tag. */<br />    public void endElement(<br />            String uri, String localName, String qName) {<br />        stack.pop();<br />        if ("rss".equals(qName)) {<br />            rssParsingComplete = true;<br />        } else {<br />            // Do something with title, link, description, such <br />            // as displaying it to the user.<br />        }<br />    }<br />}</p>
<p>注意，startDocument()、startElement()、stopElement() 以及 characters() 方法的定义提供了 SAX2 XML 解析所需的最低功能。</p>
<p>支持 Web 服务的 J2ME 无线工具包</p>
<p>J2ME Wireless Toolkit v2.1 包含开发充分利用 J2ME Web Service 的 MIDlet 所需的库。该工具包还包含 JAX-RPC 存根生成器，可以从命令行或 KToolbar 菜单运行它，如下图所示：</p>
<p>图 6  J2ME 无线工具包 2.1 实用程序和存根生成器</p>
<p>在 Utilities 屏幕上选择 Stub Generator。在出现的对话框中，输入描述要使用服务的输入 WSDL 文档的 URL、生成文件的输出路径以及用于已生成存根文件的软件包名。相应地选择 CLDC 1.0 或 1.1。</p>
<p>J2ME 无线工具包的 v2.1 还包含一个示例应用程序 JSR172Demo。</p>
<p>结束语</p>
<p>J2ME Web 服务规范（J2ME Web Services Specification）使 J2ME 平台上的 Web 服务和 XML 解析编程接口标准化了。随着 JAX-RPC 子集 API 的出现，开发人员可以使用 Java 编程语言和熟悉的 JAX-RPC API 来创建使用基于 XML 的远程服务的应用程序。而不必处理 HTTP、SOAP 和数据转换的底层细节。而且随着 JAXP 子集 API 的引入，XML 解析目前已是 J2ME 平台本身不可分割的一部分。J2ME Web Services API 消除了开发人员在每个应用程序中包含用于远程调用和 XML 解析代码的需要。</p>
<p>这些功能强大的 API 允许移动应用程序更容易地访问基于 Web 的服务，但是开发人员千万别忘了 J2ME 设备提供的受限制的应用程序环境。仅仅移植现有的基于 XML 的桌面或企业应用程序不是开发 J2ME 平台的 Web 服务客户机的适当方法。对设备处理能力、电池寿命、网络带宽以及安全性的适当考虑也是不可缺少的。</p>
<p>更多信息</p>
<p>JSR 172: J2ME Web Services Specification <br />Web Services Interoperability Organization (WS-I) <br />World Wide Web Consortium (W3C) <br />Organization for the Advancement of Structured Information Standards (OASIS) <br />The Complexity of Developing Mobile Networked Data Services, J2ME Wireless Connection Wizard For Sun Java System Studio <br />W3C WSDL website</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 19:08:57</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e8%bf%90%e8%a1%8c/" title="运行">运行</a>, <a href="https://www.iamivan.net/tag/%e6%9c%8d%e5%8a%a1/" title="服务">服务</a>, <a href="https://www.iamivan.net/tag/%e5%ba%94%e7%94%a8%e7%a8%8b%e5%ba%8f/" title="应用程序">应用程序</a>, <a href="https://www.iamivan.net/tag/%e6%94%af%e6%8c%81/" title="支持">支持</a>, <a href="https://www.iamivan.net/tag/saxparser/" title="saxparser">saxparser</a>, <a href="https://www.iamivan.net/tag/%e7%94%9f%e6%88%90api%e6%96%87%e6%a1%a3/" title="生成API文档">生成API文档</a>, <a href="https://www.iamivan.net/tag/%e5%ad%90%e9%9b%86/" title="子集">子集</a>, <a href="https://www.iamivan.net/tag/java-%e8%b0%83%e7%94%a8%e5%ba%93-%e8%b0%83%e7%94%a8api/" title="java 调用库 调用api">java 调用库 调用api</a>, <a href="https://www.iamivan.net/tag/%e5%ad%98%e6%a0%b9/" title="存根">存根</a>, <a href="https://www.iamivan.net/tag/web%c2%a0api%c2%a0%c2%a0%e5%bc%82%e5%b8%b8%e5%a4%84%e7%90%86/" title="web&nbsp;api&nbsp;&nbsp;异常处理">web&nbsp;api&nbsp;&nbsp;异常处理</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>J2ME Web 服务入门的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z4wdJrp.html" rel="bookmark">JAX-WS Web服务入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java API for XML Web Services (JAX-WS) 2.0, JSR 224 是 Java EE 5 平台的一个重要组成部分.作为 Java API for XML-based RPC 1.1(JAX-RPC) 的后续发行,JAX-WS使用 Java 技术简化了 Web 服务的开发任务.它解决了 JAX-RPC 1.1 中存在的一些问题,提供了对 SOAP 1.1.SOAP 1.2 和 XML 等多个协议的支持,并提供了一个工具专门支持 HTTP 等其他协议.JAX-W			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/6b3xXAM.html" rel="bookmark">C&num;创建Web服务&lpar;入门图解&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				web|web服务|创建       微软在其.Net战略中,对其主推的Web服务做了大肆的宣扬.现在,Web服务正如火如荼地发展着,相关的各项新技术层出不穷.Web服务的发展正构筑着互联网时代美好的明天.在本文中,我将向大家介绍Web服务的一些基本知识以及如何用Visual C#一步一步地创建一个简单的Web服务. 一．Web服务概述: Web服务是一种新的Web应用程序分支,它们是自包含.自描述.模块化的应用,可以发布.定位.通过Web调用.Web服务可以执行从简单的请求到复杂商务处理的任何			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8YAY3z.html" rel="bookmark">使用ASP&period;NET Web Api构建基于REST风格的服务实战系列教程【三】&mdash;&mdash;Web Api入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:使用ASP.NET Web Api构建基于REST风格的服务实战系列教程[三]--Web Api入门 系列导航地址http://www.cnblogs.com/fzrain/p/3490137.html 前言 经过前2节的介绍,我们已经把数据访问层搭建好了,从本章开始就是Web Api部分了.在正式开始之前,再一次回顾一下Web Api的应用场景:Web Api可以与 MVC,WebForm结合使用,也可以作为一个单独的Web服务.在正式讨论Web Api的配置以及如何构造我们的URI来消			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ballnwz.html" rel="bookmark">异步操作和Web服务，第1部分&colon;异步事务入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				并不是所有的 Web 服务都同步工作:某些情况下,对 Web 服务请求的响应并不是立即提供的,而是在最初的请求事务完成后的某个时候提供.Web 服务规范和标准并不显式支持这种 异步操作:但是,那些标准的确包含可以作为异步操作基础的基础架构和机制.在本文中,Holt Adams 说明了为什么任何 Web 服务设计师都需要理解异步操作是如何运行的.本文将帮助您开始使自己的服务适应异步环境. Web 服务调用本质上是异步的,因为服务提供者必须能够接收来自客户机的请求而无需通知.但是,有时 Web 服务			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/balaJnz.html" rel="bookmark">WF从入门到精通（第十九章）：把工作流发布为Web服务</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				学习完本章,你将掌握: 1.了解要把你的工作流暴露为XML Web服务来使用的话,各个工作流活动该怎样进行设计 2.了解在ASP.NET中宿主工作流需要些什么 3.看看在基于XML Web服务的工作流中如何进行错误(fault)处理 4.针对各种情况对你的基于XML Web服务的工作流进行配置 在前一章&quot;在你的工作流中调用Web服务&quot;中,你看到了如何从你客户端一侧的工作流中使用WF所提供的InvokeWebService活动来调用XML Web服务.但是,在那章的应用程序范例中的XML			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1RBn8p.html" rel="bookmark">WF从入门到精通（第十八章）：在你的工作流中调用Web服务</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				学习完本章,你将掌握: 1.在你的工作流中调用web服务 2.添加和配置web服务代理 3.在你的工作流中进行会话(sessions)管理 拿我来说,一些基于网络进行数据的发送和接收的事情很吸引我,由此多年以来我很喜欢写基于通信的代码.当我看到wf内置了连接web服务和作为web服务的能力时,我就更深入地对其进行了研究. wf集成了几个基于xml web服务的活动,我们将在本章调查客户端(client)一侧的活动.(在最后一章&quot;把工作流作为web服务&quot;中我们将讨论服务器一侧的活动).在			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnxonZb.html" rel="bookmark">JAX-WS Web服务客户机入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本教程所需要的软件 开始之前,需要在您的计算机上下载并安装以下软件: NetBeans IDE 6.0 Web &amp; Java EE. Java Standard Development Kit(JDK)版本 5.0 或版本 6.0. Glassfish V2 或 Tomcat Web Server,两者都可在 NetBeans IDE 6.0 安装程序中选择安装. 客户机界面如下所示,其中含有从 Web 服务接收的所有数据: 到本教程结束时,应用程序的功能将包括提供待检查文本.对 Web 服务调			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/VMrd86z.html" rel="bookmark">建立安全 Web 服务</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				web|安全 摘要: Microsoft SOAP Toolkit 2.0 提供一个灵活的框架,可以为各种 Intranet 和 Internet 解决方案构建可伸缩的 Web 服务.在这两种方案中,安全性都是建立可靠服务的重要因素.SOAP Toolkit 2.0 支持基于 IIS 安全基础结构的 Internet 安全性.本文介绍了如何使用 Microsoft SOAP Toolkit 2.0 建立安全解决方案. 简介 与任何分布式协议相同,成功的 SOAP 应用程序的关键在于获得安全性权限			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/2pLv6Lb.html" rel="bookmark">在ASP&period;NET开发中使用非&period;Net Web服务</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				asp.net|web|web服务 对于如何使用 WebRequest 和 WebResponse 类在 URI 上生成 POST 请求,在微软的 .Net 快速入门教程中有详细的描述(http://chs.gotdotnet.com/quickstart/howto/doc/WebRequests/clientPOST.aspx),简要引用如下: WebResponse 类是抽象(在 Visual Basic 中为 MustInherit)基类,协议特定的响应类从该抽象基类派生.应用程序可以使			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJ2j7z.html" rel="bookmark" class="title">网站运营&colon;软性推广文章写作技巧</a>
					<div>
						技巧|推广|网站运营 站长最关心的是网站的流量:最需要的技巧是推广技巧.赚钱技巧.关于推广技巧已经被别人写的烂了,其中一些方法几乎是每篇都有,那便是经典技巧.虽然是经典技巧也许效果未必如想象中那么经典 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz772Rz.html" rel="bookmark" class="title">Fireworks插件&mdash;Transform使用说明</a>
					<div>
						(注:Transform插件现已包含在Genius Tool Kit插件中) 一. 变形功能 Transform插件的开发目的是为设计师提供一个精确控制对象变形的工具,他以数控的方式改变对象的旋转角度 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/apXJ6vb.html" rel="bookmark" class="title">加快百度收录结石网我用这招</a>
					<div>
						很多站长做站最烦恼的就是一个网站的收录了,其中收录首页是做站的开始,一个网站连首页都没有,网民搜索的时候自然没有你的站点信息了,经过一段时间的学习,看了不下数百篇文章,当然了这些文章都是前辈们的经验, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1R63jp.html" rel="bookmark" class="title">MS SQL基础教程：警报</a>
					<div>
						DTS Designer 与DTS Wizard 一样都是在同构或异构数据源间进行数据的导入.导出和转换.但是,DTS Designer 是一个图形工具,它使创建和编辑DTS 包的工作变得更简单.轻松 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlRjqLz.html" rel="bookmark" class="title">&period;Net Micro Framework 模拟器详解 &ndash; 基本原理</a>
					<div>
						摘要:虚拟仪器(VI)技术在很多高成本的工业项目中扮演着越来越重要的角色,在电子产品的开发中,各种模拟器也为广大开发者方提供了便利,提高了生产力.本文介 绍了微软最新的嵌入式开发框架.Net Micr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY2a9xp.html" rel="bookmark" class="title">用SQL Storage Compress压缩SQL Server数据库文件</a>
					<div>
						Rea Hat提供了类似的工具SQL Storage Compress,而且号称可以达到90%的压缩比.SQL Storage Compress提供14天的使用版,下载后安装会启动HyperBac C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3NQjgz.html" rel="bookmark" class="title">sqlServer使用ROW</a>
					<div>
						  --1.看到NHibernate是这样写的分页,感觉写起来比较容易理解(应该不会有效率问题吧?) --with只是定一个别名? [sql]  代码如下   with query as (selec ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj7k4nM.html" rel="bookmark" class="title">php将字符串转换成16进制的方法</a>
					<div>
						 这篇文章主要介绍了php将字符串转换成16进制的方法,涉及php中bin2hex函数的使用技巧,非常具有实用价值,需要的朋友可以参考下     本文实例讲述了php将字符串转换成16进制的方法.分享 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5oY3Wb.html" rel="bookmark" class="title">win8修改任务栏图标大小的操作方法</a>
					<div>
						  我们已经习惯了诸如win7系统中任务拦上的小图标,在使用win8系统时发现任务拦上的图标变大了,给人感觉很别扭,有没有方法让win8系统中任务栏上图标变的小一点呢?还真有,请看河东小编是怎么设置的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8O9Zb.html" rel="bookmark" class="title">后期如何将美貌冰封</a>
					<div>
						  美女摄影师@JessieYu13- 为大家带来作品&lt;冰释&gt;的一些后期过程.她坦言:&quot;其实真心没有什么技术含量,只需要你有足够的耐心还有实现心中所想的动力!后期没有什么捷径可走 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN12qob.html" rel="bookmark" class="title">酷狗音乐怎么下载到手机上图文教程？</a>
					<div>
						  1.首先需要将您的手机通过数据线连接到电脑,将手机调试好,使在电脑上可以看到手机上的储存设备,如果您内存不够就需要手装有内存卡. 2.打开酷狗软件,没有也可以在网上下载安装,如图您可以使用搜索功能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo707vb.html" rel="bookmark" class="title">win8&period;1无法安装4月更新怎么办？</a>
					<div>
						  win8.1无法安装4月更新怎么办?         win8.1无法安装4月更新怎么办?win10/win7无影响!在微软发布的4月更新后,很多用户都反映出现了各种安装问题,比如IE积累性安全更 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLaEwWz.html" rel="bookmark" class="title">提高U盘读写速度最新小窍门</a>
					<div>
						  今天放个4G文件到我的忆捷8G,老说磁盘已满,上百度一问,才知道要改成NTFS的, FAT32文件最大2G .可是这一折腾,发现了一个诀窍, 居然可以手动提升U盘成 写23MB/S 读33M/S  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYR78Vp.html" rel="bookmark" class="title">4种方法让Mac桌面变整洁实用方法</a>
					<div>
						  这是个老生常谈的问题,桌面反映一个人的性格,其实这句话不无道理,千万别让你的桌面乱成一锅粥,有损形象.很多人习惯把桌面当成一个存储箱,什么东西都放上面,文件夹.快捷方式.图标.图片.文档.安装文件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b24GGqp.html" rel="bookmark" class="title">2&period;0缓存问题</a>
					<div>
						问题描述 我写了个类用来加载treeview,可放在缓存里却不能用请高手帮忙.protectedvoidPage_Load(objectsender,EventArgse){if(Cache[&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBK7XKM.html" rel="bookmark" class="title">JFrame里怎么添加一个JMenu和JPanel</a>
					<div>
						问题描述 JFrame里怎么添加一个JMenu和JPanel 我想在一个面板里添加一个菜单栏 然后点击里面的菜单项时 下面可以显示做好的class 这是我写的 可是显示不出来 public MainF ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6Rgaz.html" rel="bookmark" class="title">AOC不闪式3D液晶热卖</a>
					<div>
						AOC e2352Pz液晶显示器在外观上非常时尚,机身采用了黑色烤漆工艺,而23英寸屏幕带给用户最为宽阔的视野.今天笔者获悉,这款3D液晶显示器仅售1199元,这一价格只能在亚马逊商城得到啊.感兴趣的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8kea9M.html" rel="bookmark" class="title">PostgreSQL汉字转拼音</a>
					<div>
						标签 PostgreSQL , 拼音 , 汉字转拼音 背景 在有些应用中,可能会有对拼音搜索.拼音首字母搜索.中文搜索共存的需求.在PostgreSQL中如何实现这个需求呢? 关键是函数转拼音和首字母 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBWdDb.html" rel="bookmark" class="title">服务端如何处理https 发来的数据？？需要解码吗？？？</a>
					<div>
						问题描述 服务端如何处理https 发来的数据??需要解码吗??? 我是做服务端的,现在需要做一个数据交互的模块.要用到https 但是以前没用过,求哪位大神告诉我在服务端这边如何处理https传来这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRg4Yp.html" rel="bookmark" class="title">C&num;并行编程-Parallel</a>
					<div>
						原文:C#并行编程-Parallel 菜鸟学习并行编程,参考&lt;C#并行编程高级教程.PDF&gt;,如有错误,欢迎指正.   TPL中引入了一个新命名空间System.Threading.Tas ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV0GVkM.html" rel="bookmark" class="title">图片-这种界面是怎么做出来的，求大神告知，，我是学JAVA的</a>
					<div>
						问题描述 这种界面是怎么做出来的,求大神告知,,我是学JAVA的 解决方案 这不是web程序,而是桌面程序,说easyui的明显不靠谱. 这个程序模仿的是office 2007的Ribbon,有很多这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAAqjJM.html" rel="bookmark" class="title">各位大神，我想在form上实现全屏图片切换，图片在本地文件夹中，用imagelist动态添加，效果能像PPT全屏演示那样</a>
					<div>
						问题描述 总体效果要像PPT演示一样,能下一页,上一页来进行图片的翻页,图片路径需要相对路径,图片需要分类,能选择不同的类别图片来进行播放. 解决方案 解决方案二:这不就是一个列表,你循环显示就行了, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNjaGPM.html" rel="bookmark" class="title">&lbrack;译&rsqb; 快速介绍JavaScript中的CSP</a>
					<div>
						Communicating Sequential Processes 的 7 个示例 CSP 是什么? 一般来说, 它是写并行代码的一套方案. 在 Go 语言里自带该功能, Clojure 通过基于  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2REPBb.html" rel="bookmark" class="title">MySQL5&period;7&colon; 动态调整buffer pool size</a>
					<div>
						在5.7.5中提供了一个新功能,能够动态的对buffer pool size进行调整. 对应的changelog entry: InnoDB: The innodb_buffer_pool_size  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnqKNM.html" rel="bookmark" class="title">php-XAMPP无法加载ssh2&period;so模块</a>
					<div>
						问题描述 XAMPP无法加载ssh2.so模块 如题:为加载ssh2.so模块,安装libssh2-1.4.2和ssh2-0.12后,执行make test命令进行测试,显示如下错误,我该如何解决这个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjmN0M.html" rel="bookmark" class="title">微博营销的最高境界&mdash;&mdash;超越粉丝</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 微博就像一个小镇,像一个乡村酒吧, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXPqQb.html" rel="bookmark" class="title">Pinterest正式推出推广图钉广告</a>
					<div>
						[TechWeb报道]近日,Pinterest在其官方博客中表示,广告主目前能够付费,让自己的Pin出现在更好的位置.2013年开始Pinterest便开始和部分营销主合作,在网站上发布推广 图钉式广 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3ZrwAz.html" rel="bookmark" class="title">JS正则表达式详解&lbrack;收藏&rsqb;&lowbar;正则表达式</a>
					<div>
						JS的正则表达式 //校验是否全由数字组成  function isDigit(s)    {    var patrn=/^[0-9]{1,20}$/;    if (!patrn.exec(s)) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boLdlBM.html" rel="bookmark" class="title">用expect实现的自动登录到多台服务器的shell脚本&lowbar;linux shell</a>
					<div>
						复制代码 代码如下: #!/usr/bin/expect -fset ipaddress [lindex $argv 0]set passwd [lindex $argv 1]set timeout  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKqdq7p.html" rel="bookmark" class="title">jquery&plus;ashx无刷新GridView数据显示插件&lpar;实现分页、排序、过滤功能&rpar;&lowbar;jquery</a>
					<div>
						理由:jquery简单,兼容性好且容易封装.废话不多说,马上开始我们的Jquery插件编写吧.应该有很多人写过类似的插件,我也是有些模仿flexGrid的形式. 需求:GridView显示数据,无刷新 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.038 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
